#!/usr/bin/perl -w
# use strict;
use CGI qw(:standard);
use CGI::Carp qw(warningsToBrowser fatalsToBrowser);
use Fcntl qw(:flock SEEK_END);
# require "qpcgi-lib.pl";
print header;
print start_html(-title=>"Results");

# $qpip = $ENV{'REMOTE_ADDR'};
$qpStudentName = param('qpStudentName');
$qpStudentEmail = param('qpStudentEmail');
$etime = param('etime');
# append the qpa extension
# XXX there should be an error if the file can't be opened
$filename = param('answerfile');
open(ansfile, $filename . ".qpa") || die "can't open answerfile: $1\n";

while(<ansfile>) {
if (/=/) {
# clean off any leading spaces
$_ =~ s/^\s*//;
# strip off any embedded # comments
$_ =~ s/\s*#.*//;
# strip off any spaces next to the =
$_ =~ s/\s*=\s*/=/;
# strip off any spaces next to the end of line
$_ =~ s/\s*$//;
($num, $answer) = split ('=', $_, 2);

$realans{$num} = $answer;
}
}
close ansfile;
$quiztitle = $realans{'QuizTitle'};



print "Test Name $quiztitle <br>\n";
print "Student Name $qpStudentName <br>\n";
print "Student Email Address: $qpStudentEmail <br>\n";
print "Number of questions is $realans{NoQuestions} <br>\n";
# set date time
$datestring = localtime();
print "Local date and time $datestring <br>\n";
$qpip = $ENV{'REMOTE_ADDR'};
print "Remote ip adress: $qpip <br>\n";
print "Elapse Time: $etime seconds<br><br>\n";

my $correct = 0;
my $fldname;
my $ans;
@rightwrong=();
for ($i = 1; $i <= $realans{'NoQuestions'}; $i++) {
	$fldname = "rad" . $i;
	$ans = "A" . $i;
# print "fldname = $fldname tparam(flddname) is ", param($fldname), "<br>\n";
# print "ans = $realans{$ans} <br>\n";

	if ("$realans{$ans}" eq param($fldname)) {
	    $correct++;
# print "You got this one correct $correct <br><br>\n";
$rightwrong[$i]=param($fldname);
} else {
# print "You got this one wrong <br>\n";

$rightwrong[$i] = "x" . param($fldname);

# print "<br><br>\n";
}
}
print "List of answers<br><br>\n";

for ($i = 1; $i <= $realans{'NoQuestions'}; $i++) {
print "$i",$rightwrong[$i], "  ";
}
print "<br><br>\n";
print "correct answers = $correct <br>\n";
$score = ($correct/$realans{'NoQuestions'})*100;
$rscore = sprintf("%.1f", $score);
print "Score is $rscore percent <br>\n";
if ($score>=70) {
$passfail="Pass";
print "You passsed <br> \n";

print "<A HREF=\"$realans{'URLPass'}\">$realans{'URLPassText'}</A><br>\n";
} else {
$passfail="Fail";
print " You failed <br>\n";
print "<A HREF=\"$realans{'URLFail'}\">$realans{'URLFailText'}</A>";
}
print "\n";



# if ($realans{'ScoreFile'} eq test1) {
#open(MYFILE1, ">>datadir/test1.qpd")|| die "cannot open testx.qpd: $!";	
# }  



$tempfile1 = $filename . ".qpd";

open (MYFILE1, ">>$tempfile1") || die "cannot open testx.qpd: $!";
 
flock(MYFILE1, 2) || die;
    # make sure that we append to it
    seek(MYFILE1, 0, 2);
print MYFILE1 "\n";

print MYFILE1 "Quiz title: $quiztitle \| Name: $qpStudentName \| $qpStudentEmail \| $passfail \| $rscore  \| Elapse Time: $etime seconds \| Local date and time $datestring \| Remote ip adress: $qpip  Answers (x for wrong) ";

for ($i = 1; $i <= $realans{'NoQuestions'}; $i++) {
print MYFILE1 "$i",$rightwrong[$i], "  ";
}
flock(MYFILE1, 8);	
close (MYFILE1);


print end_html;

